Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4451)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4452)
@@ -4669,41 +4672,41 @@
                 IF ( sw_radiation .AND. sun_up )  THEN
 !
-!--                Get albedo for direct/diffusive long/shortwave radiation at 
-!--                current (y,x)-location from surface variables. 
-!--                Only obtain it from horizontal surfaces, as RRTMG is a single 
+!--                Get albedo for direct/diffusive long/shortwave radiation at
+!--                current (y,x)-location from surface variables.
+!--                Only obtain it from horizontal surfaces, as RRTMG is a single
 !--                column model
-!--                (Please note, only one loop will entered, controlled by 
+!--                (Please note, only one loop will entered, controlled by
 !--                start-end index.)
                    DO  m = surf_lsm_h%start_index(j,i),                        &
                            surf_lsm_h%end_index(j,i)
                       rrtm_asdir(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_asdir(:,m) )
+                                            surf_lsm_h%rrtm_asdir(m,:) )
                       rrtm_asdif(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_asdif(:,m) )
+                                            surf_lsm_h%rrtm_asdif(m,:) )
                       rrtm_aldir(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_aldir(:,m) )
+                                            surf_lsm_h%rrtm_aldir(m,:) )
                       rrtm_aldif(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_aldif(:,m) )
-                   ENDDO             
+                                            surf_lsm_h%rrtm_aldif(m,:) )
+                   ENDDO
                    DO  m = surf_usm_h%start_index(j,i),                        &
                            surf_usm_h%end_index(j,i)
                       rrtm_asdir(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_asdir(:,m) )
+                                            surf_usm_h%rrtm_asdir(m,:) )
                       rrtm_asdif(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_asdif(:,m) )
+                                            surf_usm_h%rrtm_asdif(m,:) )
                       rrtm_aldir(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_aldir(:,m) )
+                                            surf_usm_h%rrtm_aldir(m,:) )
                       rrtm_aldif(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_aldif(:,m) )
+                                            surf_usm_h%rrtm_aldif(m,:) )
                    ENDDO
 !
-!--                Due to technical reasons, copy optical depths and other 
-!--                to dummy arguments which are allocated on the exact size as the 
+!--                Due to technical reasons, copy optical depths and other
+!--                to dummy arguments which are allocated on the exact size as the
 !--                rrtmg_sw is called.
 !--                As one dimesion is allocated with zero size, compiler complains
-!--                that rank of the array does not match that of the 
-!--                assumed-shaped arguments in the RRTMG library. In order to 
-!--                avoid this, write to dummy arguments and give pass the entire 
-!--                dummy array. Seems to be the only existing work-around.  
+!--                that rank of the array does not match that of the
+!--                assumed-shaped arguments in the RRTMG library. In order to
+!--                avoid this, write to dummy arguments and give pass the entire
+!--                dummy array. Seems to be the only existing work-around.
                    ALLOCATE( rrtm_sw_taucld_dum(1:nbndsw+1,0:0,k_topo+1:nzt_rad+1) )
                    ALLOCATE( rrtm_sw_ssacld_dum(1:nbndsw+1,0:0,k_topo+1:nzt_rad+1) )
@@ -4714,5 +4717,5 @@
                    ALLOCATE( rrtm_sw_asmaer_dum(0:0,k_topo+1:nzt_rad+1,1:nbndsw+1) )
                    ALLOCATE( rrtm_sw_ecaer_dum(0:0,k_topo+1:nzt_rad+1,1:naerec+1)  )
-     
+
                    rrtm_sw_taucld_dum = rrtm_sw_taucld(1:nbndsw+1,0:0,k_topo+1:nzt_rad+1)
                    rrtm_sw_ssacld_dum = rrtm_sw_ssacld(1:nbndsw+1,0:0,k_topo+1:nzt_rad+1)
@@ -4733,11 +4736,11 @@
                                   rrtm_tlev(:,k_topo+1:nzt_rad+2),             &
                                   rrtm_tsfc,                                   &
-                                  rrtm_h2ovmr(:,k_topo+1:nzt_rad+1),           &                               
-                                  rrtm_o3vmr(:,k_topo+1:nzt_rad+1),            &        
+                                  rrtm_h2ovmr(:,k_topo+1:nzt_rad+1),           &
+                                  rrtm_o3vmr(:,k_topo+1:nzt_rad+1),            &
                                   rrtm_co2vmr(:,k_topo+1:nzt_rad+1),           &
                                   rrtm_ch4vmr(:,k_topo+1:nzt_rad+1),           &
                                   rrtm_n2ovmr(:,k_topo+1:nzt_rad+1),           &
                                   rrtm_o2vmr(:,k_topo+1:nzt_rad+1),            &
-                                  rrtm_asdir,                                  & 
+                                  rrtm_asdir,                                  &
                                   rrtm_asdif,                                  &
                                   rrtm_aldir,                                  &
@@ -4763,8 +4766,8 @@
                                   rrtm_sw_asmaer_dum,                          &
                                   rrtm_sw_ecaer_dum,                           &
-                                  rrtm_swuflx(:,k_topo:nzt_rad+1),             &  
-                                  rrtm_swdflx(:,k_topo:nzt_rad+1),             & 
-                                  rrtm_swhr(:,k_topo+1:nzt_rad+1),             & 
-                                  rrtm_swuflxc(:,k_topo:nzt_rad+1),            & 
+                                  rrtm_swuflx(:,k_topo:nzt_rad+1),             &
+                                  rrtm_swdflx(:,k_topo:nzt_rad+1),             &
+                                  rrtm_swhr(:,k_topo+1:nzt_rad+1),             &
+                                  rrtm_swuflxc(:,k_topo:nzt_rad+1),            &
                                   rrtm_swdflxc(:,k_topo:nzt_rad+1),            &
                                   rrtm_swhrc(:,k_topo+1:nzt_rad+1),            &
@@ -4800,12 +4803,12 @@
                       surf_lsm_h%rad_sw_in(m)     = rrtm_swdflx(0,k_topo)
                       surf_lsm_h%rad_sw_out(m)    = rrtm_swuflx(0,k_topo)
-                   ENDDO             
+                   ENDDO
                    DO  m = surf_usm_h%start_index(j,i),                        &
                            surf_usm_h%end_index(j,i)
                       surf_usm_h%rad_sw_in(m)     = rrtm_swdflx(0,k_topo)
                       surf_usm_h%rad_sw_out(m)    = rrtm_swuflx(0,k_topo)
-                   ENDDO 
-!
-!--                Vertical surfaces. Fluxes are obtain at respective vertical 
+                   ENDDO
+!
+!--                Vertical surfaces. Fluxes are obtain at respective vertical
 !--                level of the surface element
                    DO  l = 0, 3
@@ -4815,5 +4818,5 @@
                          surf_lsm_v(l)%rad_sw_in(m)  = rrtm_swdflx(0,k)
                          surf_lsm_v(l)%rad_sw_out(m) = rrtm_swuflx(0,k)
-                      ENDDO             
+                      ENDDO
                       DO  m = surf_usm_v(l)%start_index(j,i),                  &
                               surf_usm_v(l)%end_index(j,i)
@@ -4821,5 +4824,5 @@
                          surf_usm_v(l)%rad_sw_in(m)  = rrtm_swdflx(0,k)
                          surf_usm_v(l)%rad_sw_out(m) = rrtm_swuflx(0,k)
-                      ENDDO 
+                      ENDDO
                    ENDDO
 !
@@ -4829,5 +4832,5 @@
                    rad_sw_out = 0.0_wp
 !--             !!!!!!!! ATTENSION !!!!!!!!!!!!!!!
-!--             Surface radiative fluxes should be also set to zero here                  
+!--             Surface radiative fluxes should be also set to zero here
 !--                Save surface radiative fluxes onto respective surface elements
 !--                Horizontal surfaces
@@ -4836,12 +4839,12 @@
                       surf_lsm_h%rad_sw_in(m)     = 0.0_wp
                       surf_lsm_h%rad_sw_out(m)    = 0.0_wp
-                   ENDDO             
+                   ENDDO
                    DO  m = surf_usm_h%start_index(j,i),                        &
                            surf_usm_h%end_index(j,i)
                       surf_usm_h%rad_sw_in(m)     = 0.0_wp
                       surf_usm_h%rad_sw_out(m)    = 0.0_wp
-                   ENDDO 
-!
-!--                Vertical surfaces. Fluxes are obtain at respective vertical 
+                   ENDDO
+!
+!--                Vertical surfaces. Fluxes are obtain at respective vertical
 !--                level of the surface element
                    DO  l = 0, 3
@@ -4851,5 +4854,5 @@
                          surf_lsm_v(l)%rad_sw_in(m)  = 0.0_wp
                          surf_lsm_v(l)%rad_sw_out(m) = 0.0_wp
-                      ENDDO             
+                      ENDDO
                       DO  m = surf_usm_v(l)%start_index(j,i),                  &
                               surf_usm_v(l)%end_index(j,i)
@@ -4857,5 +4860,5 @@
                          surf_usm_v(l)%rad_sw_in(m)  = 0.0_wp
                          surf_usm_v(l)%rad_sw_out(m) = 0.0_wp
-                      ENDDO 
+                      ENDDO
                    ENDDO
                 ENDIF
@@ -4868,5 +4871,5 @@
 !--    Finally, calculate surface net radiation for surface elements.
        IF (  .NOT.  radiation_interactions  ) THEN
-!--       First, for horizontal surfaces    
+!--       First, for horizontal surfaces
           DO  m = 1, surf_lsm_h%ns
              surf_lsm_h%rad_net(m) = surf_lsm_h%rad_sw_in(m)                   &
@@ -4882,7 +4885,7 @@
           ENDDO
 !
-!--       Vertical surfaces. 
+!--       Vertical surfaces.
 !--       Todo: weight with azimuth and zenith angle according to their orientation!
-          DO  l = 0, 3     
+          DO  l = 0, 3
              DO  m = 1, surf_lsm_v(l)%ns
                 surf_lsm_v(l)%rad_net(m) = surf_lsm_v(l)%rad_sw_in(m)          &
@@ -4907,5 +4910,5 @@
 
        CALL exchange_horiz( rad_sw_in,  nbgp )
-       CALL exchange_horiz( rad_sw_out, nbgp ) 
+       CALL exchange_horiz( rad_sw_out, nbgp )
        CALL exchange_horiz( rad_sw_hr,    nbgp )
        CALL exchange_horiz( rad_sw_cs_hr, nbgp )
@@ -4921,5 +4924,5 @@
 !> Calculate the cosine of the zenith angle (variable is called zenith)
 !------------------------------------------------------------------------------!
-    SUBROUTINE calc_zenith( day_of_year, second_of_day ) 
+    SUBROUTINE calc_zenith( day_of_year, second_of_day )
 
        USE palm_date_time_mod,                                                 &
@@ -4973,5 +4976,5 @@
 ! Description:
 ! ------------
-!> Calculates surface albedo components based on Briegleb (1992) and 
+!> Calculates surface albedo components based on Briegleb (1992) and
 !> Briegleb et al. (1986)
 !------------------------------------------------------------------------------!
@@ -4990,6 +4993,6 @@
 !
 !--           Loop over surface elements
-              DO  ind_type = 0, SIZE( surf%albedo_type, 1 ) - 1
-           
+              DO  ind_type = 0, SIZE( surf%albedo_type, 2 ) - 1
+
 !
 !--              Ocean
@@ -5081,5 +5084,5 @@
            surf%rrtm_asdif = albedo_urb
            surf%rrtm_aldir = albedo_urb
-           surf%rrtm_aldif = albedo_urb  
+           surf%rrtm_aldif = albedo_urb
 !
 !--     Darkness
@@ -5150,7 +5153,7 @@
           DEALLOCATE ( rrtm_sw_tauaer )
           DEALLOCATE ( rrtm_sw_ssaaer )
-          DEALLOCATE ( rrtm_sw_asmaer ) 
-          DEALLOCATE ( rrtm_sw_ecaer )   
- 
+          DEALLOCATE ( rrtm_sw_asmaer )
+          DEALLOCATE ( rrtm_sw_ecaer )
+
           DEALLOCATE ( rrtm_swdflx  )
           DEALLOCATE ( rrtm_swdflxc )
@@ -5236,6 +5239,6 @@
 
 !
-!--    Calculate pressure levels on zu and zw grid. Sounding data is added at 
-!--    top of the LES domain. This routine does not consider horizontal or 
+!--    Calculate pressure levels on zu and zw grid. Sounding data is added at
+!--    top of the LES domain. This routine does not consider horizontal or
 !--    vertical variability of pressure and temperature
        ALLOCATE ( rrtm_play(0:0,nzb+1:nzt_rad+1)   )
@@ -5263,7 +5266,7 @@
 
 !
-!--    Calculate temperature/humidity levels at top of the LES domain. 
-!--    Currently, the temperature is taken from sounding data (might lead to a 
-!--    temperature jump at interface. To do: Humidity is currently not 
+!--    Calculate temperature/humidity levels at top of the LES domain.
+!--    Currently, the temperature is taken from sounding data (might lead to a
+!--    temperature jump at interface. To do: Humidity is currently not
 !--    calculated above the LES domain.
        ALLOCATE ( rrtm_tlay(0:0,nzb+1:nzt_rad+1)   )
@@ -5299,6 +5302,6 @@
        ALLOCATE ( rrtm_sw_tauaer(0:0,nzb+1:nzt_rad+1,1:nbndsw+1) )
        ALLOCATE ( rrtm_sw_ssaaer(0:0,nzb+1:nzt_rad+1,1:nbndsw+1) )
-       ALLOCATE ( rrtm_sw_asmaer(0:0,nzb+1:nzt_rad+1,1:nbndsw+1) ) 
-       ALLOCATE ( rrtm_sw_ecaer(0:0,nzb+1:nzt_rad+1,1:naerec+1) )    
+       ALLOCATE ( rrtm_sw_asmaer(0:0,nzb+1:nzt_rad+1,1:nbndsw+1) )
+       ALLOCATE ( rrtm_sw_ecaer(0:0,nzb+1:nzt_rad+1,1:naerec+1) )
 
 !
@@ -5332,5 +5335,5 @@
        rrtm_swdflx  = 0.0_wp
        rrtm_swuflx  = 0.0_wp
-       rrtm_swhr    = 0.0_wp  
+       rrtm_swhr    = 0.0_wp
        rrtm_swuflxc = 0.0_wp
        rrtm_swdflxc = 0.0_wp
@@ -5348,5 +5351,5 @@
        rrtm_lwdflx  = 0.0_wp
        rrtm_lwuflx  = 0.0_wp
-       rrtm_lwhr    = 0.0_wp  
+       rrtm_lwhr    = 0.0_wp
        rrtm_lwuflxc = 0.0_wp
        rrtm_lwdflxc = 0.0_wp
@@ -5367,5 +5370,5 @@
 !> Read trace gas data from file and convert into trace gas paths / volume
 !> mixing ratios. If a user-defined input file is provided it needs to follow
-!> the convections used in RRTMG (see respective netCDF files shipped with 
+!> the convections used in RRTMG (see respective netCDF files shipped with
 !> RRTMG)
 !------------------------------------------------------------------------------!
@@ -5422,5 +5425,5 @@
           DEALLOCATE ( rrtm_cfc22vmr )
           DEALLOCATE ( rrtm_ccl4vmr  )
-          DEALLOCATE ( rrtm_h2ovmr  )     
+          DEALLOCATE ( rrtm_h2ovmr  )
        ENDIF
 
@@ -5446,18 +5449,18 @@
        nc_stat = NF90_INQ_DIMID( id, "Pressure", id_dim )
        CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
-       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, len = np) 
+       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, len = np)
        CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
 
        nc_stat = NF90_INQ_DIMID( id, "Absorber", id_dim )
        CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
-       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, len = nabs ) 
+       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, len = nabs )
        CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
-   
-
-!
-!--    Allocate pressure, and trace gas arrays     
+
+
+!
+!--    Allocate pressure, and trace gas arrays
        ALLOCATE( p_mls(1:np) )
-       ALLOCATE( trace_mls(1:num_trace_gases,1:np) ) 
-       ALLOCATE( trace_mls_tmp(1:nabs,1:np) ) 
+       ALLOCATE( trace_mls(1:num_trace_gases,1:np) )
+       ALLOCATE( trace_mls_tmp(1:nabs,1:np) )
 
 
@@ -5482,5 +5485,5 @@
 !
 !--       Replace missing values by zero
-          WHERE ( trace_mls(n,:) > 2.0_wp )  
+          WHERE ( trace_mls(n,:) > 2.0_wp )
              trace_mls(n,:) = 0.0_wp
           END WHERE
@@ -5497,10 +5500,10 @@
        ALLOCATE ( rrtm_plev_tmp(1:nzt_rad+2) )
 
-       rrtm_play_tmp(1:nzt_rad)   = rrtm_play(0,1:nzt_rad) 
+       rrtm_play_tmp(1:nzt_rad)   = rrtm_play(0,1:nzt_rad)
        rrtm_plev_tmp(1:nzt_rad+1) = rrtm_plev(0,1:nzt_rad+1)
        rrtm_play_tmp(nzt_rad+1)   = rrtm_plev(0,nzt_rad+1) * 0.5_wp
        rrtm_plev_tmp(nzt_rad+2)   = MIN( 1.0E-4_wp, 0.25_wp                    &
                                          * rrtm_plev(0,nzt_rad+1) )
- 
+
 !
 !--    Calculate trace gas path (zero at surface) with interpolation to the
@@ -5509,5 +5512,5 @@
 
        trace_mls_path(nzb+1,:) = 0.0_wp
-       
+
        DO k = nzb+2, nzt_rad+2
           DO m = 1, num_trace_gases
@@ -5516,7 +5519,7 @@
 !
 !--          When the pressure level is higher than the trace gas pressure
-!--          level, assume that 
-             IF ( rrtm_plev_tmp(k-1) > p_mls(1) )  THEN             
-                
+!--          level, assume that
+             IF ( rrtm_plev_tmp(k-1) > p_mls(1) )  THEN
+
                 trace_mls_path(k,m) = trace_mls_path(k,m) + trace_mls(m,1)     &
                                       * ( rrtm_plev_tmp(k-1)                   &
@@ -5526,5 +5529,5 @@
 
 !
-!--          Integrate for each sounding level from the contributing p_mls 
+!--          Integrate for each sounding level from the contributing p_mls
 !--          levels
              DO n = 2, np
@@ -5553,10 +5556,10 @@
              ENDDO
 
-             IF ( rrtm_plev_tmp(k) < p_mls(np) )  THEN 
+             IF ( rrtm_plev_tmp(k) < p_mls(np) )  THEN
                 trace_mls_path(k,m) = trace_mls_path(k,m) + trace_mls(m,np)    &
                                       * ( MIN( rrtm_plev_tmp(k-1), p_mls(np) ) &
                                           - rrtm_plev_tmp(k)                   &
-                                        ) / g 
-             ENDIF  
+                                        ) / g
+             ENDIF
           ENDDO
        ENDDO
@@ -5617,5 +5620,5 @@
 
                 rrtm_h2ovmr(0,:) = trace_path_tmp(:)
-                
+
              CASE DEFAULT
 
@@ -5772,5 +5775,5 @@
      INTEGER(iwp)                      ::  pc_box_dimshift    !< transform for best accuracy
      INTEGER(iwp), DIMENSION(0:3)      ::  reorder = (/ 1, 0, 3, 2 /)
-                                           
+
      REAL(wp), DIMENSION(3,3)          ::  mrot               !< grid rotation matrix (zyx)
      REAL(wp), DIMENSION(3,0:nsurf_type)::  vnorm             !< face direction normal vectors (zyx)
@@ -5797,5 +5800,5 @@
      REAL(wp)                          ::  area_surf          !< total area of surfaces in all processor
      REAL(wp)                          ::  area_hor           !< total horizontal area of domain in all processor
-#if defined( __parallel )     
+#if defined( __parallel )
      REAL(wp), DIMENSION(1:7)          ::  combine_allreduce   !< dummy array used to combine several MPI_ALLREDUCE calls
      REAL(wp), DIMENSION(1:7)          ::  combine_allreduce_l !< dummy array used to combine several MPI_ALLREDUCE calls
@@ -5850,9 +5853,9 @@
      ENDIF
 !
-!--  Split downwelling shortwave radiation into a diffuse and a direct part. 
+!--  Split downwelling shortwave radiation into a diffuse and a direct part.
 !--  Note, if radiation scheme is RRTMG or diffuse radiation is externally
 !--  prescribed, this is not required. Please note, in case of external
-!--  radiation, the clear-sky model is applied during spinup, so that 
-!--  radiation need to be split also in this case. 
+!--  radiation, the clear-sky model is applied during spinup, so that
+!--  radiation need to be split also in this case.
      IF ( radiation_scheme == 'constant'   .OR.                                &
           radiation_scheme == 'clear-sky'  .OR.                                &
@@ -6141,5 +6144,5 @@
      IF ( .NOT.  surface_reflections )  THEN
 !
-!--     Set nrefsteps to 0 to disable reflections        
+!--     Set nrefsteps to 0 to disable reflections
         nrefsteps = 0
         surfoutsl = albedo_surf * surfins
@@ -6549,5 +6552,5 @@
      combine_allreduce_l(6) = emiss_sum_surfl
      combine_allreduce_l(7) = area_surfl
-     
+
      CALL MPI_ALLREDUCE( combine_allreduce_l,                                  &
                          combine_allreduce,                                    &
@@ -6557,5 +6560,5 @@
                          comm2d,                                               &
                          ierr )
-     
+
      pinsw          = combine_allreduce(1)
      pinlw          = combine_allreduce(2)
@@ -6580,13 +6583,13 @@
      IF ( area_surf /= 0.0_wp )  emissivity_urb = emiss_sum_surf / area_surf
 !
-!--  Temporally comment out calculation of effective radiative temperature. 
+!--  Temporally comment out calculation of effective radiative temperature.
 !--  See below for more explanation.
 !--  (3) temperature
 !--   first we calculate an effective horizontal area to account for
 !--   the effect of vertical surfaces (which contributes to LW emission)
-!--   We simply use the ratio of the total LW to the incoming LW flux 
+!--   We simply use the ratio of the total LW to the incoming LW flux
       area_hor = pinlw / rad_lw_in_diff(nyn,nxl)
       t_rad_urb = ( ( pemitlw - pabslw + emissivity_urb * pinlw ) / &
-           (emissivity_urb * sigma_sb * area_hor) )**0.25_wp     
+           (emissivity_urb * sigma_sb * area_hor) )**0.25_wp
 
      IF ( debug_output_timestep )  CALL debug_message( 'radiation_interaction', 'end' )
@@ -6675,5 +6678,5 @@
 !> It follows Boland, Ridley & Brown (2008)
 !------------------------------------------------------------------------------!
-    SUBROUTINE calc_diffusion_radiation 
+    SUBROUTINE calc_diffusion_radiation
 
        USE palm_date_time_mod,                                                 &
@@ -6706,9 +6709,9 @@
                           0.000719_wp * cos(2.0_wp * year_angle) +             &
                           0.000077_wp * sin(2.0_wp * year_angle))
-        
-!--    
+
+!--
 !--     Under a very low angle, we keep extraterestrial radiation at
 !--     the last small value, therefore the clearness index will be pushed
-!--     towards 0 while keeping full continuity.    
+!--     towards 0 while keeping full continuity.
         IF ( cos_zenith <= lowest_solarUp )  THEN
             corrected_solarUp = lowest_solarUp
@@ -6716,7 +6719,7 @@
             corrected_solarUp = cos_zenith
         ENDIF
-        
+
         horizontalETR = etr * corrected_solarUp
-        
+
         DO i = nxl, nxr
             DO j = nys, nyn
@@ -6728,5 +6731,5 @@
             ENDDO
         ENDDO
-        
+
     END SUBROUTINE calc_diffusion_radiation
 
@@ -6826,5 +6829,5 @@
 
  END SUBROUTINE radiation_interaction
-    
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -6934,9 +6937,9 @@
 #endif
 !
-!--    Stretching (non-uniform grid spacing) is not considered in the radiation 
-!--    model. Therefore, vertical stretching has to be applied above the area 
+!--    Stretching (non-uniform grid spacing) is not considered in the radiation
+!--    model. Therefore, vertical stretching has to be applied above the area
 !--    where the parts of the radiation model which assume constant grid spacing
-!--    are active. ABS (...) is required because the default value of 
-!--    dz_stretch_level_start is -9999999.9_wp (negative). 
+!--    are active. ABS (...) is required because the default value of
+!--    dz_stretch_level_start is -9999999.9_wp (negative).
        IF ( ABS( dz_stretch_level_start(1) ) <= zw(nz_urban_t) ) THEN
           WRITE( message_string, * ) 'The lowest level where vertical ',       &
@@ -6944,5 +6947,5 @@
                                      'greater than ', zw(nz_urban_t)
           CALL message( 'radiation_interaction_init', 'PA0496', 1, 2, 0, 6, 0 )
-       ENDIF 
+       ENDIF
 !
 !--    global number of urban and plant layers
@@ -7365,7 +7368,7 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE radiation_calc_svf
-    
+
         IMPLICIT NONE
-        
+
         INTEGER(iwp)                                  :: i, j, k, d, ip, jp
         INTEGER(iwp)                                  :: isvf, ksvf, icsf, kcsf, npcsfl, isvf_surflt, imrt, imrtf, ipcgb
@@ -7411,5 +7414,5 @@
         INTEGER(kind=MPI_ADDRESS_KIND)                :: size_lad_rma
 #endif
-!    
+!
         INTEGER(iwp), DIMENSION(0:svfnorm_report_num) :: svfnorm_counts
 
@@ -7440,5 +7443,5 @@
         ray_skip_maxdist = 0
         ray_skip_minval = 0
-        
+
 !--     initialize temporary terrain and plant canopy height arrays (global 2D array!)
         ALLOCATE( nzterr(0:(nx+1)*(ny+1)-1) )
@@ -7482,5 +7485,5 @@
             IF ( raytrace_mpi_rma )  THEN
                 ALLOCATE( lad_s_ray(maxboxesg) )
-                
+
                 ! set conditions for RMA communication
                 CALL MPI_Info_create(minfo, ierr)
@@ -7556,5 +7559,5 @@
                     FLUSH(9)
                 ENDIF
-                
+
             ELSE
                 ALLOCATE( sub_lad_g(0:(nx+1)*(ny+1)*nz_plant-1) )
@@ -7589,5 +7592,5 @@
         !--
         dsitrans(:,:) = 0._wp
-        
+
         DO isurflt = 1, nsurfl
 !--         determine face centers
@@ -7694,5 +7697,5 @@
                                  SUM(ztransp(itarg0:itarg0+lowest_free_ray-1) &
                                              * vffrac(itarg0:itarg0+lowest_free_ray-1))
- 
+
 !--            Save direct solar transparency
                j = MODULO(NINT(azmid/                                          &
@@ -7760,5 +7763,5 @@
                         CALL debug_message( debug_string, 'info' )
                      ENDIF
-                     
+
                      nsvfla = k
                   ENDIF
@@ -7785,5 +7788,5 @@
                      CYCLE
                   ENDIF
-                  
+
                   sd = surf(id, isurfs)
                   sa = (/ REAL(surf(iz, isurfs), wp) - 0.5_wp * kdir(sd),  &
@@ -7801,5 +7804,5 @@
                      CYCLE
                   ENDIF
-                 
+
                   difvf = dot_product((/ kdir(sd), jdir(sd), idir(sd) /), uv) & ! cosine of source normal and direction
                       * dot_product((/ kdir(td), jdir(td), idir(td) /), -uv) &  ! cosine of target normal and reverse direction
@@ -7845,5 +7848,5 @@
                         CALL debug_message( debug_string, 'info' )
                      ENDIF
-                     
+
                      nsvfla = k
                   ENDIF
@@ -8082,5 +8085,5 @@
 !--     deallocate temporary global arrays
         DEALLOCATE(nzterr)
-        
+
         IF ( plant_canopy )  THEN
 !--         finalize mpi_rma communication and deallocate temporary arrays
@@ -8202,5 +8205,5 @@
 !--         sort and merge csf for the last time, keeping the array size to minimum
             CALL merge_and_grow_csf(-1)
-            
+
 !--         aggregate csb among processors
 !--         allocate necessary arrays
@@ -8214,6 +8217,6 @@
             ALLOCATE( ipcsflt(0:numprocs-1) )
             ALLOCATE( dpcsflt(0:numprocs-1) )
-            
-!--         fill out arrays of csf values and 
+
+!--         fill out arrays of csf values and
 !--         arrays of number of elements and displacements
 !--         for particular precessors
@@ -8257,5 +8260,5 @@
                 dcsflt(jp) = d
             ENDDO
-            
+
 !--         deallocate temporary acsf array
 !--         DEALLOCATE(acsf) - ifort has a problem with deallocation of allocatable target
@@ -8267,5 +8270,5 @@
                 DEALLOCATE(acsf2)
             ENDIF
-                    
+
 #if defined( __parallel )
 !--         scatter and gather the number of elements to and from all processor
@@ -8309,5 +8312,5 @@
                 FLUSH(9)
             ENDIF
-            
+
 #else
             npcsfl = ncsfl
@@ -8370,5 +8373,5 @@
                 ENDDO
             ENDIF
-            
+
 !--         deallocation of temporary arrays
             IF ( npcbl > 0 )  DEALLOCATE( gridpcbl )
@@ -8379,5 +8382,5 @@
                CALL debug_message( debug_string, 'info' )
             ENDIF
-            
+
         ENDIF
 
@@ -8388,13 +8391,13 @@
 
         RETURN  !todo: remove
-        
+
 !        WRITE( message_string, * )  &
 !            'I/O error when processing shape view factors / ',  &
 !            'plant canopy sink factors / direct irradiance factors.'
 !        CALL message( 'init_urban_surface', 'PA0502', 2, 2, 0, 6, 0 )
-       
+
     END SUBROUTINE radiation_calc_svf
 
-    
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -8440,9 +8443,9 @@
         INTEGER(iwp), DIMENSION(3)             :: dimnext      !< next dimension increments along path
         INTEGER(iwp), DIMENSION(3)             :: dimdelta     !< dimension direction = +- 1
-        INTEGER(iwp)                           :: px, py       !< number of processors in x and y dir before 
+        INTEGER(iwp)                           :: px, py       !< number of processors in x and y dir before
                                                                !< the processor in the question
         INTEGER(iwp)                           :: ip           !< number of processor where gridbox reside
         INTEGER(iwp)                           :: ig           !< 1D index of gridbox in global 2D array
-        
+
         REAL(wp)                               :: eps = 1E-10_wp !< epsilon for value comparison
         REAL(wp)                               :: lad_s_target   !< recieved lad_s of particular grid box
@@ -8461,5 +8464,5 @@
             CALL merge_and_grow_csf(k)
         ENDIF
-        
+
         transparency = 1._wp
         ncsb = 0
@@ -8534,5 +8537,5 @@
             dimnextdist(seldim) = (dimnext(seldim) - .5_wp - src(seldim)) / uvect(seldim)
         ENDDO
-        
+
         IF ( plant_canopy )  THEN
 #if defined( __parallel )
@@ -8549,5 +8552,5 @@
                     ENDIF
                 ENDDO
-                
+
 !--             wait for all pending local requests complete
                 CALL MPI_Win_flush_local_all(win_lad, ierr)
@@ -8557,5 +8560,5 @@
                 ENDIF
                 CALL cpu_log( log_point_s(77), 'rad_rma_lad', 'stop' )
-                
+
             ENDIF
 #endif
@@ -8586,13 +8589,13 @@
 
                 transparency = transparency * (1._wp - cursink)
-                
+
             ENDDO
         ENDIF
-        
+
         visible = .TRUE.
 
     END SUBROUTINE raytrace
-    
- 
+
+
 !------------------------------------------------------------------------------!
 ! Description:
